#include <stdarg.h>
#include <string.h>
#include "ggi_widget.h"
#include "ggi_widget_internal.h"
#include "ggi_widget_bitmap.h"

struct bitmapdata {
	ggi_widget_bitmap_t bitmap;
};

static int ggiWidgetBitmapRedraw(ggi_widget_t self,int flush) {

	struct bitmapdata *mine=self->priv;

	ggi_widget_size_t drawpos,drawsize;
	ggi_widget_color_set *colset=ggiWidgetGetColorset(self);

	ggiWidgetGetPlacement(self,&drawpos,&drawsize,NULL,1,1);
	ggiWidgetDrawBorder(self,&drawpos,&drawsize);

	ggiSetGCForeground(self->vis,ggiMapColor(self->vis,&colset->text));
	ggiSetGCBackground(self->vis,ggiMapColor(self->vis,&colset->background));
	
	ggiWidgetBitmapPlotOpaque(mine->bitmap,self->vis,self->pos.x+drawpos.x,self->pos.y+drawpos.y);
	if (flush)
		ggiFlushRegion(self->vis,self->pos.x,self->pos.y,self->size.x,self->size.y);
	return 0;
}

ggi_widget_t ggiWidgetCreateBitmap(va_list ap) {

	ggi_widget_t newid;
	struct bitmapdata *newbitmap;
	
	newid=ggiWidgetAllocate();
	if (!newid) return NULL;

	if (NULL==(newbitmap=malloc(sizeof(*newbitmap)))) {
		free(newid);
		return NULL;
	}

	newbitmap->bitmap=va_arg(ap,ggi_widget_bitmap_t);
	if (!newbitmap->bitmap) {
		free(newbitmap);
		free(newid);
		return NULL;
	}

	newid->priv=newbitmap;

	newid->min.x=newbitmap->bitmap->size.x;
	newid->min.y=newbitmap->bitmap->size.y;
	newid->opt=newid->min;
	newid->max.x=newid->max.y=-1;
	newid->redraw=ggiWidgetBitmapRedraw;

	return newid;
}
