#include "ggi_widget.h"
#include "ggi_widget_internal.h"

int ggiWidgetGetPlacement(ggi_widget_t widget,ggi_widget_size_t *pos,ggi_widget_size_t *size,int *opt,int nsx,int nsy) {

	if ( widget->size.x>=widget->opt.x &&
	     widget->size.y>=widget->opt.y) {
		if (opt) *opt=1;
		size->x=widget->opt.x;
		size->y=widget->opt.y;
	} else if ( widget->size.x>=widget->min.x &&
		    widget->size.y>=widget->min.y) {
		if (opt) *opt=0;
		size->x=widget->min.x;
		size->y=widget->min.y;
	} else {
		if (opt) *opt=0;
		pos->x =pos->y =0;
		size->x=size->y=0;
		return 1;
	}
	if ( (widget->gravity&GWT_GRAV_NORTH) &&
	     (widget->gravity&GWT_GRAV_SOUTH) ) {
	     	if (nsy) goto nostretchy;
		size->y=widget->size.y;
		pos->y =0;
	} else if ( widget->gravity&GWT_GRAV_NORTH ) {
		pos->y=0;
	} else if ( widget->gravity&GWT_GRAV_SOUTH ) {
		pos->y=widget->size.y-size->y;
	} else {
		nostretchy:
		pos->y=(widget->size.y-size->y)/2;
	}
	if ( (widget->gravity&GWT_GRAV_EAST) &&
	     (widget->gravity&GWT_GRAV_WEST) ) {
	     	if (nsx) goto nostretchx;
		size->x=widget->size.x;
		pos->x =0;
	} else if ( widget->gravity&GWT_GRAV_WEST ) {
		pos->x=0;
	} else if ( widget->gravity&GWT_GRAV_EAST ) {
		pos->x=widget->size.x-size->x;
	} else {
		nostretchx:
		pos->x=(widget->size.x-size->x)/2;
	}

	return 0;
}

int ggiWidgetDrawBorder(ggi_widget_t widget,ggi_widget_size_t *pos,ggi_widget_size_t *size) {

	ggi_widget_color_set *colset=ggiWidgetGetColorset(widget);

	ggiSetGCForeground(widget->vis,ggiMapColor(widget->vis,&colset->background_empty));
	if (pos->y>0) {
		ggiDrawBox(widget->vis,widget->pos.x,widget->pos.y,widget->size.x,pos->y);
	}
	if (pos->y+size->y<widget->size.y) {
		ggiDrawBox(widget->vis,widget->pos.x,widget->pos.y+pos->y+size->y,widget->size.x,widget->size.y-pos->y-size->y);
	}
	if (pos->x>0) {
		ggiDrawBox(widget->vis,widget->pos.x,widget->pos.y+pos->y,pos->x,size->y);
	}
	if (pos->x+size->x<widget->size.x) {
		ggiDrawBox(widget->vis,widget->pos.x+pos->x+size->x,widget->pos.y+pos->y,widget->size.x-pos->x-size->x,size->y);
	}
	return 0;
}

int ggiWidgetDrawFrame(ggi_visual_t vis,int x,int y,int w,int h,int thick) {

	ggiDrawBox(vis,x        ,y        ,w    ,thick);
	ggiDrawBox(vis,x        ,y+h-thick,w    ,thick);
	ggiDrawBox(vis,x        ,y+thick  ,thick,h-thick-thick);
	ggiDrawBox(vis,x+w-thick,y+thick  ,thick,h-thick-thick);
	return 0;
}
