#include <stdarg.h>
#include <string.h>
#include "ggi_widget.h"
#include "ggi_widget_internal.h"

struct textdata {

	ggi_widget_size_t drawpos,drawsize;
	int doopt;
	int mustfree;
	int vislen,maxlen,currlen,curstart;
	int curpos;
	int is_inside;
};

static int text_getsize(struct textdata *mine,struct ggiWidgetSize *ws) {

	ws->x=mine->vislen*8;
	ws->y=8;
	ws->x+=6;
	ws->y+=6;
	return 0;
}

static int ggiWidgetTextRedraw(ggi_widget_t self,int flush) {

	struct textdata *mine=self->priv;
	ggi_widget_color_set *colset=ggiWidgetGetColorset(self);
	int x;

	ggiWidgetDrawBorder(self,&mine->drawpos,&mine->drawsize);

	ggiSetGCForeground(self->vis,ggiMapColor(self->vis,&colset->texteditbackground));
	ggiWidgetDrawFrame(self->vis,self->pos.x+mine->drawpos.x+1,self->pos.y+mine->drawpos.y+1,
				mine->drawsize.x-2,mine->drawsize.y-2,2);

	ggiSetGCForeground(self->vis,ggiMapColor(self->vis,&colset->text));
	ggiWidgetDrawFrame(self->vis,self->pos.x+mine->drawpos.x  ,self->pos.y+mine->drawpos.y  ,
				mine->drawsize.x,mine->drawsize.y,1);

	ggiSetGCBackground(self->vis,ggiMapColor(self->vis,&colset->texteditbackground));
	
	for(x=0;x<mine->vislen;x++) {
		if (((char *)self->statevar)[x+mine->curstart]=='\0') break;
		ggiPutc(self->vis,self->pos.x+mine->drawpos.x+3+8*x,
				self->pos.y+mine->drawpos.y+3,((char *)self->statevar)[x+mine->curstart]);
		if (x+mine->curstart==mine->curpos) {
			drawcursor:
			ggiDrawVLine(self->vis,self->pos.x+mine->drawpos.x+3+8*x,
				self->pos.y+mine->drawpos.y+3,8);
			ggiDrawHLine(self->vis,self->pos.x+mine->drawpos.x+2+8*x,
				self->pos.y+mine->drawpos.y+2,3);
			ggiDrawHLine(self->vis,self->pos.x+mine->drawpos.x+2+8*x,
				self->pos.y+mine->drawpos.y+3+8,3);
		}
	}
	for(;x<mine->vislen;x++) {
		ggiPutc(self->vis,self->pos.x+mine->drawpos.x+3+8*x,
				self->pos.y+mine->drawpos.y+3,' ');
		if (x+mine->curstart==mine->curpos) {
			goto drawcursor;
		}
	}
	if (flush)
		ggiFlushRegion(self->vis,self->pos.x,self->pos.y,self->size.x,self->size.y);
	return 0;
}

int ggiWidgetTextEvent(ggi_widget_t self,gii_event *ev,ggi_widget_inputstatus_t status) {

	struct textdata *mine=self->priv;
	unsigned char *text=self->statevar;
	int is_inside;

	is_inside=(status->mouse.x>=self->pos.x+mine->drawpos.x &&
		   status->mouse.x< self->pos.x+mine->drawpos.x+mine->drawsize.x &&
		   status->mouse.y>=self->pos.y+mine->drawpos.y &&
		   status->mouse.y< self->pos.y+mine->drawpos.y+mine->drawsize.y );

	if (is_inside&&!mine->is_inside) {
		if (self->callback) {
			self->callback(GWT_CB_ENTER,self);
		}
	} else if (!is_inside&&mine->is_inside) {
		if (self->callback) {
			self->callback(GWT_CB_LEAVE,self);
		}
	};
	mine->is_inside=is_inside;

	if (self->has_focus) {
		switch(ev->any.type) {
			case evKeyPress:
			case evKeyRepeat:
				switch(ev->key.sym) {
					case GIIK_Delete:
						if (mine->curpos<mine->currlen) {
							memmove(text+mine->curpos,text+mine->curpos+1,mine->currlen-mine->curpos-1);
							*(text+mine->currlen-1)='\0';
							mine->currlen--;
							redraw:
							if (mine->curpos<mine->curstart) {
								mine->curstart=mine->curpos;
							}
							if (mine->curpos>=mine->curstart+mine->vislen) {
								mine->curstart=mine->curpos-mine->vislen+1;
							}
							self->redraw(self,1);
							if (self->callback) {
								self->callback(GWT_CB_STATECHANGE,self);
							}
						}
						break;
					case '\x08':
						if (mine->curpos>0) {
							memmove(text+mine->curpos-1,text+mine->curpos,mine->currlen-mine->curpos);
							*(text+mine->currlen-1)='\0';
							mine->currlen--;
							mine->curpos--;
							goto redraw;
						}
						break;
					case GIIK_Left:
						if (mine->curpos) {
							mine->curpos--;
							goto redraw;
						}
						break;
					case GIIK_Right:
						if (mine->curpos<mine->currlen) {
							mine->curpos++;
							goto redraw;
						}
						break;
					case '\x01':	/*Ctrl-A*/
					case GIIK_Home:
						if (mine->curpos) {
							mine->curpos=0;
							goto redraw;
						}
						break;
					case '\x05':	/*Ctrl-E*/
					case GIIK_End:
						if (mine->curpos!=mine->currlen) {
							mine->curpos=mine->currlen;
							goto redraw;
						}
						break;
					case GIIK_Enter:
						if (self->callback) {
							self->callback(GWT_CB_ACTIVATE,self);
						}
					default:
						if (ev->key.sym>=' '&&ev->key.sym<'\x7e') {
							if (mine->currlen<mine->maxlen) {
								memmove(text+mine->curpos+1,text+mine->curpos,mine->currlen-mine->curpos);
								text[mine->curpos]=ev->key.sym;
								mine->currlen++;
								if (mine->currlen<mine->maxlen) text[mine->currlen]='\0';
								mine->curpos++;
								goto redraw;
							}
						}
						break;
				}
				break;
			case evPtrButtonPress:
				if (is_inside) {
					goto get_focus_and_place;
				}
				break;
		}
	} else {
		switch(ev->any.type) {
			case evKeyPress:
			case evKeyRepeat:
				if (ev->key.sym==self->hotkey) {
					get_focus:
					ggiWidgetUnfocus(self);
					self->has_focus=1;
					return 1;
				}
				break;
			case evPtrButtonPress:
				if (is_inside) {
					get_focus_and_place:
					mine->curpos=(status->mouse.x-self->pos.x-mine->drawpos.x-3)/8;
					if (mine->curpos>mine->currlen)
						mine->curpos=mine->currlen;
					if (mine->curpos<0)
						mine->curpos=0;
					self->redraw(self,1);
					goto get_focus;
				}
				break;
		}
	}
	return 0;
}


static int ggiWidgetTextVischanged(ggi_widget_t self) {

	struct textdata *mine=self->priv;
	ggiWidgetGetPlacement(self,&mine->drawpos,&mine->drawsize,&mine->doopt,1,1);
	return 0;
}

ggi_widget_t ggiWidgetCreateText(va_list ap) {

	ggi_widget_t newid;
	struct textdata *newtext;

	newid=ggiWidgetAllocate();
	if (!newid) return NULL;

	if (NULL==(newtext=malloc(sizeof(*newtext)))) {
		free(newid);
		return NULL;
	}
	newtext->is_inside=0;
	newtext->mustfree=0;
	newtext->curstart=0;
	newtext->curpos=0;
	newid->priv=newtext;

	newid->statevar=va_arg(ap,char *);
	newtext->vislen =va_arg(ap,int);
	newtext->maxlen =va_arg(ap,int);
	if (NULL==newid->statevar) {
		if (NULL==(newid->statevar=malloc(newtext->maxlen+1))) {
			free(newtext);
			free(newid);
			return NULL;
		} else {
			memset(newid->statevar,0,newtext->maxlen+1);
			newtext->currlen=0;
			newtext->mustfree=1;
		}
	} else {
		int x;
		for(x=0;x<newtext->maxlen&&((char *)newid->statevar)[x]!='\0';x++);
		newtext->currlen=x;
	}

	text_getsize(newid->priv,&newid->min);
	newid->opt=newid->min;
	newid->max.x=newid->max.y=-1;

	newid->redraw    =ggiWidgetTextRedraw;
	newid->vischanged=ggiWidgetTextVischanged;
	newid->process_event=ggiWidgetTextEvent;

	return newid;
}
